//
// Bouncer.h
//

#include <stdio.h>

#include "Object.h"
#include "Clock.h"

#define LAST 30
#define THRESHOLD 0.1
#define TARGET_LIMIT (1 + THRESHOLD) * df::FRAME_TIME_DEFAULT

class Bouncer : public df::Object {

 private:
  int m_step_count;		// number of steps
  int m_q[LAST];		// queue of game loop times
  int m_head;			// head of queue
  int m_iteration;		// iteration number
  int m_next_iteration;		// next iteration start step
  df::Clock m_clock;		// keep track of loop timing
  int m_bounce_mark;		// number of objects supported
  bool m_do_particles;		// true if particle benchmark
  int m_balls_per_step;		// number of balls created per step
  int m_starting_balls;		// number of starting balls each round
  int m_run_time;		// if > 0, then time to run (in frames)
  int m_iteration_max;		// number of iterations
  void particleBurst();		// add particle burst

 public:
  Bouncer(bool do_particles, int balls_per_step, int starting_balls,
	  int run_time, int interation_max);
  void createBalls(int count);
  int getBounceMark();	
  void startBounce();
  void stopBounce();
  int eventHandler(const df::Event *p_e);
};


